/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
var global = this;
var domloader = {};

domloader.loadDom = function(jsclasses, prefixes) {
	djConfig = {
		baseRelativePath: "/"
	};

	load("core/internal/module/jazzenv.js");
	window.location = "ajaxmodule.html";
	
	load("dojo/_base/_loader/bootstrap.js");
	load("dojo/_base/_loader/loader.js");
	load("core/internal/analyzer/hostenv_jazz0_9.js");
	
    dojo._name = "rhino";
    dojo.isBrowser = true;
    
	dojo._loadUri = function(uri, cb) {
		var contents = null;
		logDebug("load ["+uri+"]");
		try{
			if(cb){
				cb(load(uri));
			}else{
				load(uri);
			}
			return true;
		}catch(e){
			logError("load for ('" + uri + "') failed. Exception: " + e.name + " : [" + e.message +"] at line "+e.lineNumber);
			return false;
		}
	};
	
	dojo._getText = function(/*URI*/ uri, /*Boolean*/ fail_ok) {
		logDebug("getText for ["+uri+"]");
		try{
			var contents = readText(uri);
			if (contents === null) {
				logError("Contents of ["+uri+"] is empty");
			}
			return contents;
		}catch(e){
			logError("getText('" + uri + "') failed. Exception: " + e);
			if(fail_ok){ return null; }
			throw e;
		}
	};
	
	dojo._xhrObj= function(){
		return new XMLHttpRequest();
	};
	
	dojo._isDocumentOk = function(http) {
		return true;
	};
	
	dojo.addOnWindowUnload = function(/*Object?*/obj, /*String|Function?*/ functionName){
	};
	
	alert = function(msg) {
		print("alert : "+msg);
	};
		
	for(var x = 0; x < prefixes.length; x++){
		dojo.registerModulePath(prefixes[x][0], prefixes[x][1]);
	}

	load("dojo/_base.js");
	document.cookie = "";
	
	var transformer = Packages.javax.xml.transform.TransformerFactory.newInstance().newTransformer();
	transformer.setOutputProperty(Packages.javax.xml.transform.OutputKeys.METHOD, "html");
	transformer.setOutputProperty(Packages.javax.xml.transform.OutputKeys.OMIT_XML_DECLARATION, "yes");
	transformer.setOutputProperty(Packages.javax.xml.transform.OutputKeys.INDENT, "yes");
	
	if (global["net"] !== undefined) {
		var _net = net;
		delete net;
	}
	if (global["com"] !== undefined) {
		var _com = com;
		delete com;
	}
	if (global["org"] !== undefined) {
		var _org = org;
		delete org;
	}
	
	dojo.provide("doh.runner");
	dojo.provide("doh.robot");
	dojo.provide("dojo.robot");
	dojo.provide("dojo.robotx");
	dojo.provide("dijit.robot");
	dojo.provide("dijit.robotx");
	
	for (var jsclassIndex = 0; jsclassIndex < jsclasses.length; jsclassIndex++) {
		var jsclass = jsclasses[jsclassIndex];
		try {
			dojo.require(jsclass);
			var constructor = dojo.getObject(jsclass);
			constructor.prototype.postCreate = function(){
			};
			var widget = new constructor({
				id: jsclass,
				widgetsInTemplate: false
			}, dojo.byId("test"));
			
			var source = new Packages.javax.xml.transform.dom.DOMSource(widget.domNode._dom);
			var stringWriter = new Packages.java.io.StringWriter();
			var result = new Packages.javax.xml.transform.stream.StreamResult(stringWriter);
			
			transformer.transform(source, result);
			
			addDom(jsclass, stringWriter.toString());
		}
		catch (exc) {
			logError("Failed to load DOM for ajax module ["+jsclass+"] " + exc.name + " : [" + exc.message +"] at line "+exc.lineNumber);
		}
	}
	if (_net !== null) {
		net = _net;
	}
	if (_com !== null) {
		com = _com;
	}
	if (_org !== null) {
		org = _org;
	}
};